import logging
# import urllib.parse
# import websocket
# import os
# import threading
# import socketio
# import time
# from websockets.sync.client import connect

class CustomFormatter(logging.Formatter):

    grey = "\x1b[38;20m"
    green = "\x1b[1;32m"
    yellow = "\x1b[33;20m"
    red = "\x1b[31;20m"
    bold_red = "\x1b[31;1m"
    reset = "\x1b[0m"
    format = (
        "%(asctime)s - %(name)s - %(levelname)s - %(message)s (%(filename)s:%(lineno)d)"
    )

    FORMATS = {
        logging.DEBUG: grey + format + reset,
        logging.INFO: green + format + reset,
        logging.WARNING: yellow + format + reset,
        logging.ERROR: red + format + reset,
        logging.CRITICAL: bold_red + format + reset,
    }

    def format(self, record):
        log_fmt = self.FORMATS.get(record.levelno)
        formatter = logging.Formatter(log_fmt)
        return formatter.format(record)


class FileFormatter(logging.Formatter):

    format = (
        "%(asctime)s - %(name)s - %(levelname)s - %(message)s (%(filename)s:%(lineno)d)"
    )

    FORMATS = {logging.ERROR: format, logging.CRITICAL: format}

    def format(self, record):
        log_fmt = self.FORMATS.get(record.levelno)
        formatter = logging.Formatter(log_fmt)
        return formatter.format(record)
    
# class SocketFormatter(logging.Formatter):

#     grey = "\x1b[38;20m"
#     green = "\x1b[1;32m"
#     yellow = "\x1b[33;20m"
#     red = "\x1b[31;20m"
#     bold_red = "\x1b[31;1m"
#     reset = "\n"
#     format = (
#         "%(asctime)s - %(name)s - %(levelname)s - %(message)s (%(filename)s:%(lineno)d)"
#     )

#     FORMATS = {
#         logging.DEBUG: grey + format + reset,
#         logging.INFO: green + format + reset,
#         logging.WARNING: yellow + format + reset,
#         logging.ERROR: red + format + reset,
#         logging.CRITICAL: bold_red + format + reset,
#     }

#     def format(self, record):
#         log_fmt = self.FORMATS.get(record.levelno)
#         formatter = logging.Formatter(log_fmt)
#         return formatter.format(record)
# websock_conn = False
# try:
#     websocket = connect("ws://localhost:5003/ws")
#     websock_conn = True
# except Exception as e:
#     print(e)
    #logger.removeHandler(SocketHandler())

# class SocketHandler(logging.Handler):
#     def emit(self, record):
#         #log_entry = self.format(record)
#         if "finished" in record.message:
#              websocket.send(urllib.parse.unquote(str(record.message)))
#         else:
#             split_msg = str(record.message).split("/")[:-1]
#             fucked_msg = urllib.parse.quote(str(record.message).split("/")[-1])
#             full_msg = "/".join(split_msg) + fucked_msg
#             try:
#                 link = full_msg.split("Trying to get: ")[1]
#                 href = '<a href="' + str(link) + '">' + str(link) + '</a>'
#                 full_aids = "Trying to get: " + href
#                 websocket.send(full_aids)
#             except Exception as e:
#                 websocket.send(full_msg)



logger = logging.getLogger("Marketbot")
logger.setLevel(logging.INFO)
ch = logging.StreamHandler()
ch.setLevel(logging.INFO)
ch.setFormatter(CustomFormatter())
logger.addHandler(ch)


fh = logging.FileHandler("errors.txt", encoding="utf-8")
fh.setFormatter(FileFormatter())
fh.setLevel(logging.ERROR)
logger.addHandler(fh)

# if websock_conn is True:
#     sh = logging.StreamHandler()
#     sh.setLevel(logging.INFO)
#     logger.addHandler(SocketHandler())







