import asyncio

import websockets


async def handler(websocket):
    while True:
        try:
            message = await websocket.recv()
        except websockets.ConnectionClosedOK:
            break
        except websockets.exceptions.ConnectionClosedError:
            print("conn closed :(")
            break
        print(message)

async def main():
    async with websockets.serve(handler, "0.0.0.0", 5003):
        await asyncio.Future()  # run forever


if __name__ == "__main__":
    asyncio.run(main())
